var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState, useEffect } from "react";
import { PaginationItem, PaginationLink, Pagination } from "reactstrap";
import { range } from "lodash";
import "./style/bootstrap.min.css";
var GeneratedPagination = function (_a) {
    var onClick = _a.onClick, resetPagination = _a.resetPagination, _b = _a.numberOfScreens, numberOfScreens = _b === void 0 ? 5 : _b, onPreviousArrow = _a.onPreviousArrow, onNextArrow = _a.onNextArrow, _c = _a.paginationPageLinkStyle, paginationPageLinkStyle = _c === void 0 ? {} : _c, _d = _a.paginationContainerStyle, paginationContainerStyle = _d === void 0 ? {} : _d;
    var _e = useState(1), currentPage = _e[0], setCurrentPage = _e[1];
    var _f = useState(1), starter = _f[0], setStarter = _f[1];
    useEffect(function () {
        if (resetPagination === 1) {
            setCurrentPage(1);
            setStarter(1);
        }
    }, [resetPagination]);
    var onPreviousArrow2 = function () {
        if (starter === 1) {
            return;
        }
        var newStarter = starter - numberOfScreens;
        setStarter(newStarter);
        setCurrentPage(newStarter);
        onClick(newStarter);
        if (onPreviousArrow)
            onPreviousArrow();
    };
    var onNextArrow2 = function () {
        var newStarter = starter + numberOfScreens;
        setStarter(newStarter);
        setCurrentPage(newStarter);
        onClick(newStarter);
        if (onNextArrow)
            onNextArrow();
    };
    return (React.createElement(Pagination, { "aria-label": "Page navigation", style: __assign({}, paginationContainerStyle) },
        React.createElement(PaginationItem, { key: "pre" },
            React.createElement(PaginationLink, { previous: true, onClick: onPreviousArrow2, style: __assign({}, paginationPageLinkStyle) })),
        range(starter, starter + numberOfScreens).map(function (counter, index) {
            return (React.createElement(PaginationItem, { key: counter, active: counter === currentPage },
                React.createElement(PaginationLink, { style: __assign({}, paginationPageLinkStyle), onClick: function () {
                        setCurrentPage(counter);
                        onClick(counter);
                    } }, counter)));
        }),
        React.createElement(PaginationItem, { key: "next" },
            React.createElement(PaginationLink, { next: true, onClick: onNextArrow2, style: __assign({}, paginationPageLinkStyle) }))));
};
export { GeneratedPagination };
